This documentation is for Dovecot v2.x, see wiki1 for v1.x documentation.
Differences between revisions 3 and 4
Revision 3 as of 2007-03-22 01:22:14
Size: 6247
Editor: TimoSirainen
Comment: only v0.99 has ".subscriptions" file with maildir! and cleaned up the page.
Revision 4 as of 2007-03-22 01:29:30
Size: 6709
Editor: TimoSirainen
Comment:
Deletions are marked like this. Additions are marked like this.
Line 2: Line 2:

If you want a transparent migration, the biggest problem is preserving message UIDs. See ["Migration"] for the problems this may cause. None of the solutions described below preserve the message UIDs.

== Convert plugin ==

Dovecot has a plugin which allows you to convert between any two mailbox formats supported by Dovecot. The conversion is done when the user logs in for the first time, or using {{{convert-tool}}} binary. See ["Plugins/Convert"].

Converting between mailbox formats

If you want a transparent migration, the biggest problem is preserving message UIDs. See ["Migration"] for the problems this may cause. None of the solutions described below preserve the message UIDs.

Convert plugin

Dovecot has a plugin which allows you to convert between any two mailbox formats supported by Dovecot. The conversion is done when the user logs in for the first time, or using convert-tool binary. See ["Plugins/Convert"].

Converting from mbox to Maildir

[http://batleth.sapienti-sat.org/projects/mb2md/ mb2md] is a script which can convert the files for you.

Check also the User-Contributed Maildir Support section [http://www.qmail.org/top.html#usersoft on the qmail community site] for more choices.

Example (user's mail in ~someuser/mail and inbox in /var/mail/someuser):

cd ~someuser
mb2md-3.20.pl -s mail -R
mb2md-3.20.pl -m -d /var/mail/incoming/someuser
mv mail mail.old

Now the mail will be in ~someuser/Maildir.

Hierarchy separator change

The default hierarchy separator with Maildir is '.' instead of '/' which is common with mboxes. To keep the migration transparent to users, you can keep the '/' separator by using [:Namespaces:namespaces]. In any case you need to replace the '/' with '.' in the subscriptions file:

  • sed 's:/:.:g' subscriptions > subscriptions.new
    mv subscriptions.new subscriptions

UW-IMAP's subscriptions file is in ~/.mailboxlist. Dovecot's mbox subscriptions is in <mbox root dir>/.subscriptions. Dovecot's Maildir subscriptions is in <maildir root>/subscriptions.

Also if you're migrating from UW-IMAP, you probably had "mail/" prefixes in the mailbox names. You can again use [:Namespaces:namespaces] to let clients use the prefix, or you can tell your users to remove the namespace prefix from their clients and change the subscriptions file:

sed 's/mail\.//' subscriptions > subscriptions.new
mv subscriptions.new subscriptions

Note that because Maildir uses '.' as the hierarchy separator in filesystem, it's not possible to have mailbox names containing '.' characters, even if you changed the separator in namespaces. If you really want to have dots, the only way to do this is by modifying the filesystem separator in MAILDIR_FS_SEP and MAILDIR_FS_SEP_S defines in src/lib-storage/index/maildir/maildir-storage.h file in the sources.

Converting from Maildir to mbox

This is especially helpful if you want to archive your mail to a single file for storage on a CD, a PC, etc. But it can also be helpful if you want to use [:MailboxFormat/mbox:mbox] with Dovecot.

Use the reformail program that comes with [http://www.courier-mta.org/maildrop/ maildrop]. You can also use the formail program that comes with [http://www.procmail.org/ procmail]. Here is a simple script showing how this works.

To use it, adjust the script to invoke the right command according to your system.

Then cd to the user's home directory (one level above Maildir) and run the script with two arguments: the mailbox name (You can use "." for the top-level folder), and the output mbox filename, for example:

cd ~hans
perl dw-maildirtombox.pl . >/tmp/hans-inbox
perl dw-maildirtombox.pl Sent >/tmp/hans-sent

# dw-maildirtombox.pl
# dw = Dovecot Wiki :-)
# NOTE! The output file must not contain single quotes (')!
# figure out which program to run
$cmd="reformail -f1";
system("$cmd </dev/null >/dev/null 2>/dev/null") == 0 or $cmd="formail";
system("$cmd </dev/null >/dev/null 2>/dev/null") == 0
or die "cannot find reformail or formail on your \$PATH!\nAborting";
$dir=$ARGV[0];
$outputfile=$ARGV[1];
if (($outputfile eq '') || ($dir eq ''))
{ die "Usage: ./archivemail.pl mailbox outputfile\nAborting"; }
if (!stat("Maildir/$dir/cur") || !stat("Maildir/$dir/new"))
{ die "Maildir/$dir is not a maildir.\nAborting"; }
@files = (<Maildir/$dir/cur/*>,<Maildir/$dir/new/*>);
foreach $file (@files) {
  next unless -f $file; # skip non-regular files
  next unless -s $file; # skip empty files
  next unless -r $file; # skip unreadable files
  $file =~ s/'/'"'"'/;  # escape ' (single quote)
  $run = "cat '$file' | $cmd >>'$outputfile'";
  system($run) == 0 or warn "cannot run \"$run\".";
}

Converting from MBX to mbox

If you are using UW-IMAP and using the [:MailboxFormat/mbx:MBX format], you will need to convert it to [:MailboxFormat/mbox:mbox] format. The conversion process isn't pretty, but here is a script that works. You will need to get and compile the mailutil program from the [http://www.washington.edu/imap/ UW-IMAP web site].

# Written by Marc Perkel - public domain
# overhauled by Matthias Andree, 2006
# Usage: mbx-convert <filename>
# This code assumes there a user named "marc" with the primary group "marc".
# Change to any real user on your system.
# Yes - it look bizzare - but it gets the job done
# abort on error
set -e
user=marc
group=marc
homedir=/home/$user
if [ $# -ne 1 ] ; then
  echo >&2 "Usage: $0 <filename>"
  exit 1
fi
# set up automatic cleanup
trap 'rm -f "${homedir}"/in.$$ "${homedir}"/out.$$' 0
# First copy to users home dir and make the user the owner
cp "$1" "${homedir}/in.$$"
chown "$user":"$group" "${homedir}/in.$$"
# Run mailutil to convert as the user other than root
# mailutil requires this
su "$user" -c "mailutil copy in.$$ \#driver.unix/out.$$"
# create new file with same permissions/owner as old
cp -p "$1" "${1}.new"
# cat instead of copy leaves the original owner and permissions alone
if cat "${homedir}/out.$$" >"${1}.new" ; then
  # cat succeeded, rename file into place
  mv "${1}.new" "$1"
else
  # cat failed, remove temp file
  rm -f "${1}.new"
  exit 1
fi

Make a copy of some folders and test it first. Once you are satisfied that it works then:

  • Write a script to convert all your files.
  • Shut down your email system so files can't be modified
  • Copy all your email to a backup location in case you have to revert
  • Run the script
  • Turn on Dovecot and test to verify it is working
  • Important - make sure that you changed your SMTP configuration to write mbox and not MBX.
  • Turn on SMTP and verify it is all working

User comments:

  • Is this hassle actually necessary? I have run mailutil as root like this (mailutil as provided by the PINE 4.61 package for SUSE Linux 10.0): mailutil copy /tmp/foo.mbx.orig '#driver.unix//tmp/foo.test' and did not encounter any problems. -- MatthiasAndree, 2006-05-18

None: Migration/MailFormat (last edited 2019-01-11 08:40:22 by AkiTuomi)